<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Storage;use App\Category;
use App\Product;
use App\CategoriesFilter;
use DB;
use Illuminate\Support\Facades\Auth;

class CategoryController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $categories = Category::all();
        return view('Backend.Categories.list')->with('categories',$categories);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        ini_set('max_execution_time', 900);
        //$categories  = getCategories();
        $categories  = CategoriesFilter::all();
        //$collections = getcollection();
        foreach ($categories as $key => $value) {
            $options_create = '';
            $options_update = '';
            $arrayProducts = array();
            //$catProducts = getCatProducts($value->id);
            $product_log = Product::where('category_id','=',$value->av_id)->get();
            foreach($product_log as $key => $catProduct)
            {
                $arrayProducts[] = '{ "product_id":'.$catProduct->shopify_id.'}';
            }
            $category = Category::where('av_id','=',$value->av_id)->first();
            if($category)
            {
                if($value->image)
                {
                    $options_update = '{"custom_collection": {"id": "'.$category->shopify_id.'","title": "'.$value->name.'" , "body_html": "<p>'.$value->description.'</p>", "image": {"src": "'.$value->image.'", "alt": "'.$value->name.'"}, "collects": ['.implode(', ', $arrayProducts).'], "published": true  } }';
                }
                else
                {
                    $options_update = '{"custom_collection": {"id": "'.$category->shopify_id.'","title": "'.$value->name.'" , "body_html": "<p>'.$value->description.'</p>", "collects": ['.implode(', ', $arrayProducts).'], "published": true  } }';
                }

                $curl = curl_init();

                curl_setopt_array($curl, array(
                CURLOPT_URL => "https://".env("shop-url")."/admin/api/2020-04/custom_collections/".$category->shopify_id.".json",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_SSL_VERIFYHOST => 0,
                CURLOPT_SSL_VERIFYPEER => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "PUT",
                CURLOPT_POSTFIELDS =>$options_update,
                CURLOPT_HTTPHEADER => array(
                    "X-Shopify-Access-Token:".env("Password"),
                    "Content-Type: application/json"
                    ),
                ));

                $response = curl_exec($curl);
                $err = curl_error($curl);

                curl_close($curl);
                if ($err) 
                {
                    return response()->json(['status' => 'false', 'message' => "cURL Error #:" . $err]);
                } 
                else 
                {
                    $custom_collection = json_decode($response);
                    if($custom_collection && isset($custom_collection->custom_collection))
                    {
                        $category->av_id = $value->av_id;
                        $category->shopify_id = $custom_collection->custom_collection->id;
                        $category->name = $value->name;
                        $category->description = $value->description;
                        if($value->image)
                        {
                            $category->image = $value->image;
                        }
                        $category->parent_category_id = $value->parent_category_id;
                        $category->created_by = Auth::user()->id;
                        $category->save(); 
                    }
                }
            }
            else{
                if($value->image)
                {
                    $options_create = '{"custom_collection": {"title": "'.$value->name.'", "body_html": "<p>'.$value->description.'</p>", "image": {"src": "'.$value->image.'", "alt": "'.$value->name.'"}, "collects": ['.implode(', ', $arrayProducts).'], "published": true } }';
                }
                else
                {
                    $options_create = '{"custom_collection": {"title": "'.$value->name.'", "body_html": "<p>'.$value->description.'</p>", "collects": ['.implode(', ', $arrayProducts).'], "published": true } }';
                }
                $curl = curl_init();
                curl_setopt_array($curl, array(
                CURLOPT_URL => "https://".env("shop-url")."/admin/api/2020-04/custom_collections.json",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_SSL_VERIFYHOST => 0,
                CURLOPT_SSL_VERIFYPEER => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "POST",
                CURLOPT_POSTFIELDS => $options_create,
                CURLOPT_HTTPHEADER => array(
                    "X-Shopify-Access-Token:".env("Password"),
                    "Content-Type: application/json"
                    ),
                ));

                $response = curl_exec($curl);

                $err = curl_error($curl);

                curl_close($curl);
                if ($err) 
                {
                    return response()->json(['status' => 'false', 'message' => "cURL Error #:" . $err]);
                } 
                else 
                {
                    $custom_collection = json_decode($response);
                    if($custom_collection && isset($custom_collection->custom_collection))
                    {
                        $category = new Category;
                        $category->av_id = $value->av_id;
                        $category->shopify_id = $custom_collection->custom_collection->id;
                        $category->name = $value->name;
                        $category->description = $value->description;
                        if($value->image)
                        {
                            $category->image = $value->image;
                        }
                        $category->parent_category_id = $value->parent_category_id;
                        $category->creating_mathod = 'Manual Synchronization';
                        $category->created_by = Auth::user()->id;
                        $category->save(); 
                    }
                }
            }
        }
        return response()->json(['status' => 'true', 'message' => "Categories successfully synced on Shopify."]);
    }

    public function remove()
    {
        //ini_set('max_execution_time', 3600);
        ini_set('memory_limit', '2024M');
        set_time_limit(0);
        $categories = Category::all();
        foreach ($categories as $key => $category)
        {
            //dd($category);
            //Delete category from Shopify store.
            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => "https://".env("shop-url")."/admin/api/2020-10/custom_collections/".$category->shopify_id.".json",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_SSL_VERIFYHOST => 0,
                CURLOPT_SSL_VERIFYPEER => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "DELETE",
                CURLOPT_HTTPHEADER => array(
                    "X-Shopify-Access-Token:".env("Password"),
                    "Content-Type: application/json"
                ),
            ));
        
            $response = curl_exec($curl);
        
            $err = curl_error($curl);
        
            curl_close($curl);
            if ($err) 
            {
                return response()->json(['status' => 'false', 'message' => "cURL Error #:" . $err]);
            } 
            else 
            {
                $delete_category = json_decode($response);
                //Delete Category on local logs.
                $category->delete();
            }
        }
        return response()->json(['status' => 'true', 'message' => "Categories removed successfully on Shopify and local app"]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $rules =['title' => 'required','slug' => 'required'];

        $validation = $this->Validate($request,$rules);

        $slug =Category::where('slug','=',$request->slug)->first();
        if(!$slug)
        {
            $category =Category::where('title',$request->title)->first();

            if(!$category)
            {
                $category = new Category;
                $category->title = $request->title;
                $category->slug = $request->slug;
                $category->description = $request->description;
                $category->parent = 0;

                // Save Category Image
                if($request->hasFile('image'))
                {
                    $image            = $request->file('image'); 
                    $filename         = time().'.'. $image->getClientOriginalExtension();
                    $destination_path = 'public/Category-Images';
                    $image->storeAs($destination_path,$filename);
                    $category->image = $filename;
                }

                if($category->save())
                {    
                    return redirect('categories')->with('alert-success', 'Category Created Successfully');
                }
                else
                {
                    return redirect('categories/create')->with('alert-error', $validation->errors());
                }
            }
            else
            {
                return redirect('categories/create')->with('alert-error', 'This Category Name Already Exist');
            }
        }
        else
        {
            return redirect('categories/create')->with('alert-error','Please select a unique slug This slug already exists');
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $category = Category::find($id);
        return view('Backend.Categories.show')->with('category',$category);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $category = Category::find($id);
        return view('Backend.Categories.edit')->with('category',$category);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $rules =['title' => 'required','slug' => 'required'];

        $validation = $this->Validate($request,$rules);
        $category = Category::find($id);
        if($category)
        {
            $category->title = $request->title;
            $category->slug = $request->slug;
            $category->description = $request->description;
            $category->parent = 0;

            // Save Category Image
            if($request->hasFile('image'))
            {
                $image            = $request->file('image'); 
                $filename         = time().'.'. $image->getClientOriginalExtension();
                $destination_path = 'public/Category-Images';
                $image->storeAs($destination_path,$filename);
                $category->image = $filename;
            }

            if($category->update())
            {    
                return redirect('categories')->with('alert-success', 'Category Updated Successfully');
            }
            else
            {
                return redirect('categories/create')->with('alert-error', $validation->errors());
            }
        }
        else
        {
            return redirect('categories')->with('alert-error', 'Category can not find');
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $category = Category::find($id);
        if($category->delete())
        {    
            return redirect('categories')->with('alert-error', 'Category Deleted Successfully');
        }
    }

    public function manage($id)
    {
        $products = Product::where('category_id','=',$id)->where('status','!=','archive')->orderBy('series_no', 'ASC')->get();
        if(count($products) > 0)
        {
            return view('Backend.Categories.manage')->with('products',$products);
        }
        else
        {
            return redirect('categories')->with('alert-error', 'This Category no Product exist yet');
        }
    }
}
