<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Storage;use App\Product;
use App\Category;
use App\PriceKey;
use App\ProductLog;
use App\ProductVariant;
use App\ProductUpdateLog;
use App\CategoriesFilter;
use DB;
use Illuminate\Support\Facades\Auth;

class ProductsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $product = Product::all();
        return view('Backend.Products.list')->with('products',$product);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //price key for prodcts price mutipication.
        $priceKey = PriceKey::find(1);

        //Quantity key for product synic grater than this key.
        $quantityKey = PriceKey::find(2);

        //Less than price check
        $lessThan = PriceKey::find(3);

        //Grater than price check
        $graterThan = PriceKey::find(4);

        //logs table truncate.
        //$productLog_empty = DB::table('product_logs')->truncate();
        //ini_set('max_execution_time', 3600);
        ini_set('memory_limit', '2024M');
        set_time_limit(0);
        $categoriesFilter = CategoriesFilter::all();
        if(count($categoriesFilter) > 0 && !empty($categoriesFilter))
        {
            foreach ($categoriesFilter as $key => $filter) 
            {
                $catProducts = getCatProducts($filter->av_id);
                if($catProducts && isset($catProducts->products))
                {
                    foreach ($catProducts->products as $key => $product) 
                    {
                        $product_log = Product::where('av_id','=',$product->id)->first();
                        if($product_log && !empty($product_log))
                        {
                            continue;
                        }
                        else
                        {
                            if($product->tierprice[0]->price <= $lessThan->price_key && $product->tierprice[0]->price >= $graterThan->price_key)
                            {
                                //create a product log on every product.
                                $productLog = new ProductLog;
                                $productLog->sku = $product->sku;
                                $productLog->name = $product->name;
                                $productLog->stock_quantity = $product->stock_quantity;
                                $productLog->category_id = $filter->av_id;
                                $productLog->action = 'Sync product';
                                $productLog->save(); 

                                $new_price = $product->tierprice[0]->price * $priceKey->price_key;
                                $desc    = '';
                                $variants = array();
                                $desc .= 'JewelleryType : '.str_replace("\n", '', $product->JewelleryType).'<br>';

                                if($product->RingType)
                                {
                                    $desc .= 'RingType : '.$product->RingType.'<br>';
                                }
                                if($product->RingSize)
                                {
                                    $desc .= 'RingSize : '.$product->RingSize.'<br>';
                                }
                            
                                foreach ($product->specificationattributes as $key => $value) 
                                {
                                    $desc .= $value->specification_attribute_name.' : '.$value->specification_attribute_value.' <br>';
                                }

                                if(count($product->attributes) > 0 && $product->JewelleryType == 'Ring' || $product->JewelleryType == 'RING' || $product->JewelleryType == 'ring')
                                {
                                    $count_att = count($product->attributes[0]->attribute_values);
                                    $product_data = '{"product": { "title": "'.$product->name.'",   "body_html": "<strong>'.$desc.'</strong>", "product_type": "'.$product->product_type.'", "published": true, "published_scope": "global",  "images": [ { "src": "'.$product->images[0]->src.'", "alt": "'.$product->name.'" } ], "metafields": [ { "key": "'.$product->meta_keywords.'", "value": "'.$product->meta_title.'", "value_type": "string", "namespace": "global" } ], "options": [ { "name": "Size" } ], "variants": [ ';
                                    foreach ($product->attributes[0]->attribute_values as $key => $attribute_value) 
                                    {
                                        $variant = '{ "fulfillment_service": "manual", "inventory_management": "shopify", "inventory_policy": "continue", "inventory_quantity": '.$product->stock_quantity.', "requires_shipping": true, "sku": "'.$product->sku.'", "taxable": true, "price": '.$new_price.' , "weight": '.$product->weight.', "weight_unit": "kg", "title": "'.$product->name.'",';
                                        if($key == $count_att-1)
                                        {
                                            $variant .= '"option1": "'.$attribute_value->name.'"}';
                                        }
                                        else
                                        {
                                            $variant .= '"option1": "'.$attribute_value->name.'"},';
                                        }
                                        $product_data .= $variant;
                                        //array_push($variants,$variant);
                                    }
                                    $product_data .= ' ] } }';
                                }
                                else
                                {
                                    $product_data = '{"product": { "title": "'.$product->name.'",   "body_html": "<strong>'.$desc.'</strong>", "product_type": "'.$product->product_type.'", "published": true, "published_scope": "global",  "images": [ { "src": "'.$product->images[0]->src.'", "alt": "'.$product->name.'" } ], "metafields": [ { "key": "'.$product->meta_keywords.'", "value": "'.$product->meta_title.'", "value_type": "string", "namespace": "global" } ], "variants": [ ';
                                    $variant = '{ "fulfillment_service": "manual", "inventory_management": "shopify", "inventory_policy": "continue", "inventory_quantity": '.$product->stock_quantity.', "requires_shipping": true, "sku": "'.$product->sku.'", "taxable": true, "price": '.$new_price.' , "weight": '.$product->weight.', "weight_unit": "kg", "title": "'.$product->name.'"}';
                                    $product_data .= $variant.' ] } }';
                                }
                                //dd($product_data);
                                    if($product->stock_quantity >= $quantityKey->price_key)
                                    {
                                    //Create a products on Shopify Store.
                                    $curl = curl_init();
                                    curl_setopt_array($curl, array(
                                    CURLOPT_URL => "https://".env("shop-url")."/admin/api/2020-04/products.json",
                                    CURLOPT_RETURNTRANSFER => true,
                                    CURLOPT_ENCODING => "",
                                    CURLOPT_MAXREDIRS => 10,
                                    CURLOPT_TIMEOUT => 0,
                                    CURLOPT_SSL_VERIFYHOST => 0,
                                    CURLOPT_SSL_VERIFYPEER => 0,
                                    CURLOPT_FOLLOWLOCATION => true,
                                    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                                    CURLOPT_CUSTOMREQUEST => "POST",
                                    //CURLOPT_POSTFIELDS =>'{"product": { "title": "'.$product->name.'",   "body_html": "<strong>'.$desc.'</strong>", "product_type": "'.$product->product_type.'", "published": true, "published_scope": "global",  "images": [ { "src": "'.$product->images[0]->src.'", "alt": "'.$product->name.'" } ], "metafields": [ { "key": "'.$product->meta_keywords.'", "value": "'.$product->meta_title.'", "value_type": "string", "namespace": "global" } ], "variants": [ { "fulfillment_service": "manual", "inventory_management": "shopify", "inventory_policy": "continue", "inventory_quantity": '.$product->stock_quantity.', "requires_shipping": true, "sku": "'.$product->sku.'", "taxable": true, "price": '.$new_price.' , "weight": '.$product->weight.', "weight_unit": "kg", "title": "'.$product->name.'", "option1": "6" } ], "options":  [ { "name": "Size","values": ["6"] } ] } }',
                                    CURLOPT_POSTFIELDS => $product_data,
                                    CURLOPT_HTTPHEADER => array(
                                        "X-Shopify-Access-Token:".env("Password"),
                                        "Content-Type: application/json"
                                        ),
                                    ));
                                
                                    $response = curl_exec($curl);
                                
                                    $err = curl_error($curl);
                                
                                    curl_close($curl);
                                    if ($err) 
                                    {
                                        return response()->json(['status' => 'false', 'message' => "cURL Error #:" . $err]);
                                    } 
                                    else 
                                    {
                                        $product_response = json_decode($response);
                                        //Create a product on local logs.
                                        if($product_response && isset($product_response->product))
                                        {
                                            $product_log = new Product;
                                            $product_log->av_id             = $product->id;
                                            $product_log->shopify_id        = $product_response->product->id;
                                            if($product->JewelleryType)
                                            {
                                                $product_log->jewellery_type = $product->JewelleryType;
                                            }
                                            //$product_log->shopify_variant_id= $product_response->product->variants[0]->id;
                                            $product_log->shopify_option_id = $product_response->product->options[0]->id;
                                            $product_log->shopify_option_values = implode(",",$product_response->product->options[0]->values);
                                            if(count($product_response->product->images) > 0)
                                            {
                                                $product_log->shopify_image_id  = $product_response->product->images[0]->id;
                                            }
                                            $product_log->name              = $product->name;
                                            $product_log->price             = $new_price;
                                            $product_log->short_description = $product->short_description;
                                            $product_log->description       = $desc;
                                            $product_log->sku               = $product->sku;
                                            $product_log->image             = $product->images[0]->src;
                                            $product_log->category_id       = $filter->av_id;
                                            $product_log->creating_mathod   = 'Manual Synchronization';
                                            $product_log->created_by        = Auth::user()->id;
                                            $product_log->save();

                                            foreach ($product_response->product->variants as $key => $variant) 
                                            {
                                                $productVariant = new ProductVariant;
                                                $productVariant->product_id = $product_log->id;
                                                $productVariant->shopify_variant_id = $variant->id;
                                                $productVariant->shopify_product_id = $variant->product_id;
                                                $productVariant->title = $variant->title;
                                                $productVariant->price = $variant->price;
                                                $productVariant->sku = $variant->sku;
                                                $productVariant->position = $variant->position;
                                                $productVariant->inventory_policy = $variant->inventory_policy;
                                                $productVariant->compare_at_price = $variant->compare_at_price;
                                                $productVariant->fulfillment_service = $variant->fulfillment_service;
                                                $productVariant->inventory_management = $variant->inventory_management;
                                                $productVariant->option1 = $variant->option1;
                                                $productVariant->option2 = $variant->option2;
                                                $productVariant->option3 = $variant->option3;
                                                $productVariant->taxable = $variant->taxable;
                                                $productVariant->barcode = $variant->barcode;
                                                $productVariant->grams = $variant->grams;
                                                $productVariant->image_id = $variant->image_id;
                                                $productVariant->weight = $variant->weight;
                                                $productVariant->weight_unit = $variant->weight_unit;
                                                $productVariant->inventory_item_id = $variant->inventory_item_id;
                                                $productVariant->inventory_quantity = $variant->inventory_quantity;
                                                $productVariant->old_inventory_quantity = $variant->old_inventory_quantity;
                                                $productVariant->requires_shipping = $variant->requires_shipping;
                                                $productVariant->admin_graphql_api_id = $variant->admin_graphql_api_id;
                                                $productVariant->save();
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                else
                {
                    return response()->json(['status' => 'server_error', 'message' => $catProducts->errors->server_error[0] ]);
                }
            }
        }
        else
        {
            return response()->json(['status' => 'false', 'message' => "Av access token API not responding"]);
        }
        return response()->json(['status' => 'true', 'message' => "Products successfully synced on Shopify."]);
    }

    public function remove()
    {
        //ini_set('max_execution_time', 3600);
        ini_set('memory_limit', '2024M');
        set_time_limit(0);
        $product_log = Product::all();
        foreach ($product_log as $key => $product) 
        {
            //Delete product veriounts on Shopify store.
            $productVariant = ProductVariant::where('product_id','=',$product->id)->get();
            if($productVariant && !empty($productVariant))
            {
                foreach ($productVariant as $key => $variant) 
                {
                    $curl = curl_init();
                    curl_setopt_array($curl, array(
                        CURLOPT_URL => "https://".env("shop-url")."/admin/api/2020-10/products/".$variant->shopify_product_id."/variants/".$variant->shopify_variant_id.".json",
                        CURLOPT_RETURNTRANSFER => true,
                        CURLOPT_ENCODING => "",
                        CURLOPT_MAXREDIRS => 10,
                        CURLOPT_TIMEOUT => 0,
                        CURLOPT_SSL_VERIFYHOST => 0,
                        CURLOPT_SSL_VERIFYPEER => 0,
                        CURLOPT_FOLLOWLOCATION => true,
                        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                        CURLOPT_CUSTOMREQUEST => "DELETE",
                        CURLOPT_HTTPHEADER => array(
                            "X-Shopify-Access-Token:".env("Password"),
                            "Content-Type: application/json"
                        ),
                    ));
                
                    $response = curl_exec($curl);
                
                    $err = curl_error($curl);
                
                    curl_close($curl);
                    if ($err) 
                    {
                        return response()->json(['status' => 'false', 'message' => "cURL Error #:" . $err]);
                    } 
                    else 
                    {
                        $delete_variant = json_decode($response);
                        //Delete product veriounts on local.
                        $variant->delete();
                    }
                }
            }

            //Delete product from Shopify store.
            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => "https://".env("shop-url")."/admin/api/2020-04/products/".$product->shopify_id.".json",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_SSL_VERIFYHOST => 0,
                CURLOPT_SSL_VERIFYPEER => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "DELETE",
                CURLOPT_HTTPHEADER => array(
                    "X-Shopify-Access-Token:".env("Password"),
                    "Content-Type: application/json"
                ),
            ));
        
            $response = curl_exec($curl);
        
            $err = curl_error($curl);
        
            curl_close($curl);
            if ($err) 
            {
                return response()->json(['status' => 'false', 'message' => "cURL Error #:" . $err]);
            } 
            else 
            {
                $delete_product = json_decode($response);
                //Delete product on local logs.
                $product->delete();
            }
        }
        return response()->json(['status' => 'true', 'message' => "Products removed successfully on Shopify and local app"]);
    }

    public function productsUpdate()
    {
        //price key for prodcts price mutipication.
        $priceKey = PriceKey::find(1);

        //Quantity key for product synic grater than this key.
        $quantityKey = PriceKey::find(2);

        //Less than price check
        $lessThan = PriceKey::find(3);

        //Grater than price check
        $graterThan = PriceKey::find(4);
        
        $getProductsUpdate = getProductsUpdate();
        if(isset($getProductsUpdate->products) && !empty($getProductsUpdate->products))
        {
            foreach ($getProductsUpdate->products as $key => $product) 
            {
                $product_log = Product::where('av_id','=',$product->id)->first();
                if($product_log && !empty($product_log))
                {
                    if($product->stock_quantity <= $quantityKey->price_key)
                    {
                        //Delete product from Shopify store.
                        $curl = curl_init();
                        curl_setopt_array($curl, array(
                            CURLOPT_URL => "https://".env("shop-url")."/admin/api/2020-04/products/".$product_log->shopify_id.".json",
                            CURLOPT_RETURNTRANSFER => true,
                            CURLOPT_ENCODING => "",
                            CURLOPT_MAXREDIRS => 10,
                            CURLOPT_TIMEOUT => 0,
                            CURLOPT_FOLLOWLOCATION => true,
                            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                            CURLOPT_CUSTOMREQUEST => "DELETE",
                            CURLOPT_HTTPHEADER => array(
                                "X-Shopify-Access-Token:".env("Password"),
                                "Content-Type: application/json"
                            ),
                        ));
                    
                        $response = curl_exec($curl);
                    
                        $err = curl_error($curl);
                    
                        curl_close($curl);
                        if ($err) 
                        {
                            return response()->json(['status' => 'false', 'message' => "cURL Error #:" . $err]);
                        } 
                        else 
                        {
                            $delete_product = json_decode($response);
                            //Delete product veriounts on local.
                            $productVariant = ProductVariant::where('product_id','=',$product_log->id)->get();
                            if($productVariant)
                            {
                                foreach ($productVariant as $key => $variant) 
                                {
                                    $variant->delete();
                                }
                            }
                            $productUpdateLog = new ProductUpdateLog;
                            $productUpdateLog->product_id = $product_log->id;
                            $productUpdateLog->av_id = $product_log->av_id;
                            $productUpdateLog->shopify_id = $product_log->shopify_id;
                            $productUpdateLog->sku = $product_log->sku;
                            $productUpdateLog->name = $product_log->name;
                            $productUpdateLog->category_id = $product_log->category_id;
                            $productUpdateLog->action = 'Deleted Product';
                            $productUpdateLog->save();
                            //Delete product on local logs.
                            $product_log->delete();
                        }
                    }
                    else
                    {
                        if($product->tierprice[0]->price <= $lessThan->price_key && $product->tierprice[0]->price >= $graterThan->price_key)
                        {
                            //create a product log on every update product.
                            $productUpdateLog = new ProductUpdateLog;
                            $productUpdateLog->product_id = $product_log->id;
                            $productUpdateLog->av_id = $product_log->av_id;
                            $productUpdateLog->shopify_id = $product_log->shopify_id;
                            $productUpdateLog->sku = $product_log->sku;
                            $productUpdateLog->name = $product_log->name;
                            $productUpdateLog->category_id = $product_log->category_id;
                            $productUpdateLog->action = 'Updated Product';
                            $productUpdateLog->save();

                            $new_price = $product->tierprice[0]->price * $priceKey->price_key;
                            $desc    = '';
                            $variants = array();
                            $desc .= 'JewelleryType : '.str_replace("\n", '', $product->JewelleryType).'<br>';

                            if($product->RingType)
                            {
                                $desc .= 'RingType : '.$product->RingType.'<br>';
                            }
                            if($product->RingSize)
                            {
                                $desc .= 'RingSize : '.$product->RingSize.'<br>';
                            }
                    
                            foreach ($product->specificationattributes as $key => $value) 
                            {
                                $desc .= $value->specification_attribute_name.' : '.$value->specification_attribute_value.' <br>';
                            }

                            if(count($product->attributes) > 0 && $product->JewelleryType == 'Ring' || $product->JewelleryType == 'RING' || $product->JewelleryType == 'ring')
                            {
                                $count_att = count($product->attributes[0]->attribute_values);
                                $product_data = '{"product": { "title": "'.$product->name.'",   "body_html": "<strong>'.$desc.'</strong>", "product_type": "'.$product->product_type.'", "published": true, "published_scope": "global",  "images": [ { "src": "'.$product->images[0]->src.'", "alt": "'.$product->name.'" } ], "metafields": [ { "key": "'.$product->meta_keywords.'", "value": "'.$product->meta_title.'", "value_type": "string", "namespace": "global" } ], "options": [ { "name": "Size" } ], "variants": [ ';
                                foreach ($product->attributes[0]->attribute_values as $key => $attribute_value) 
                                {
                                    $variant = '{ "fulfillment_service": "manual", "inventory_management": "shopify", "inventory_policy": "continue", "inventory_quantity": '.$product->stock_quantity.', "requires_shipping": true, "sku": "'.$product->sku.'", "taxable": true, "price": '.$new_price.' , "weight": '.$product->weight.', "weight_unit": "kg", "title": "'.$product->name.'",';
                                    if($key == $count_att-1)
                                    {
                                        $variant .= '"option1": "'.$attribute_value->name.'"}';
                                    }
                                    else
                                    {
                                        $variant .= '"option1": "'.$attribute_value->name.'"},';
                                    }
                                    $product_data .= $variant;
                                    //array_push($variants,$variant);
                                }
                                $product_data .= ' ] } }';
                            }
                            else
                            {
                                $product_data = '{"product": { "title": "'.$product->name.'",   "body_html": "<strong>'.$desc.'</strong>", "product_type": "'.$product->product_type.'", "published": true, "published_scope": "global",  "images": [ { "src": "'.$product->images[0]->src.'", "alt": "'.$product->name.'" } ], "metafields": [ { "key": "'.$product->meta_keywords.'", "value": "'.$product->meta_title.'", "value_type": "string", "namespace": "global" } ], "variants": [ ';
                                $variant = '{ "fulfillment_service": "manual", "inventory_management": "shopify", "inventory_policy": "continue", "inventory_quantity": '.$product->stock_quantity.', "requires_shipping": true, "sku": "'.$product->sku.'", "taxable": true, "price": '.$new_price.' , "weight": '.$product->weight.', "weight_unit": "kg", "title": "'.$product->name.'"}';
                                $product_data .= $variant.' ] } }';
                            }
                            if($product->stock_quantity >= $quantityKey->price_key)
                            {
                                //update product on shopify store.
                                $curl = curl_init();
                                curl_setopt_array($curl, array(
                                CURLOPT_URL => "https://".env("shop-url")."/admin/api/2020-04/products/".$product_log->shopify_id.".json",
                                CURLOPT_RETURNTRANSFER => true,
                                CURLOPT_ENCODING => "",
                                CURLOPT_MAXREDIRS => 10,
                                CURLOPT_TIMEOUT => 0,
                                CURLOPT_SSL_VERIFYHOST => 0,
                                CURLOPT_SSL_VERIFYPEER => 0,
                                CURLOPT_FOLLOWLOCATION => true,
                                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                                CURLOPT_CUSTOMREQUEST => "PUT",
                                //CURLOPT_POSTFIELDS =>'{"product": { "id" : "'.$product_log->shopify_id.'", "title": "'.$product->name.'",   "body_html": "<strong>'.$desc.'</strong>", "product_type": "'.$product->product_type.'",  "images": [ { "id" : "'.$product_log->shopify_image_id.'", "src": "'.$product->images[0]->src.'", "alt": "'.$product->name.'" } ], "metafields": [ { "key": "'.$product->meta_keywords.'", "value": "'.$product->meta_title.'" } ], "variants": [ { "id": "'.$product_log->shopify_variant_id.'",  "inventory_quantity": '.$product->stock_quantity.',  "sku": "'.$product->sku.'",  "price": '.$new_price.' , "weight": '.$product->weight.', "title": "'.$product->name.'" } ] } }',
                                CURLOPT_POSTFIELDS =>'{"product": { "id" : "'.$product_log->shopify_id.'", "title": "'.$product->name.'",   "body_html": "<strong>'.$desc.'</strong>", "product_type": "'.$product->product_type.'",  "images": [ { "id" : "'.$product_log->shopify_image_id.'", "src": "'.$product->images[0]->src.'", "alt": "'.$product->name.'" } ], "metafields": [ { "key": "'.$product->meta_keywords.'", "value": "'.$product->meta_title.'" } ] } }',
                                CURLOPT_HTTPHEADER => array(
                                    "X-Shopify-Access-Token:".env("Password"),
                                    "Content-Type: application/json"
                                    ),
                                ));
                            
                                $response = curl_exec($curl);
                            
                                $err = curl_error($curl);
                            
                                curl_close($curl);
                                if ($err) 
                                {
                                    return response()->json(['status' => 'false', 'message' => "cURL Error #:" . $err]);
                                } 
                                else 
                                {
                                    $product_response = json_decode($response);
                                    //update product on local logs.
                                    if($product_response)
                                    {
                                        $product_log->name              = $product->name;
                                        if($product->JewelleryType)
                                        {
                                            $product_log->jewellery_type = $product->JewelleryType;
                                        }
                                        $product_log->price             = $new_price;
                                        $product_log->short_description = $product->short_description;
                                        $product_log->description       = $desc;
                                        $product_log->sku               = $product->sku;
                                        $product_log->image             = $product->images[0]->src;
                                        $product_log->created_by        = Auth::user()->id;
                                        $product_log->save();
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        echo 'Products updated successfully.';
    }


    public function categoryProductSync($cat_id)
    {
        //price key for prodcts price mutipication.
        $priceKey = PriceKey::find(1);

        //Quantity key for product synic grater than this key.
        $quantityKey = PriceKey::find(2);

        //Less than price check
        $lessThan = PriceKey::find(3);

        //Grater than price check
        $graterThan = PriceKey::find(4);

        //logs table truncate.
        //$productLog_empty = DB::table('product_logs')->truncate();
        //ini_set('max_execution_time', 3600);
        ini_set('memory_limit', '2024M');
        set_time_limit(0);
        $catProducts = getCatProducts($cat_id);
        if($catProducts && isset($catProducts->products))
        {
            $total_product = 0;

            foreach ($catProducts->products as $key => $product)
            {
                $product_log = Product::where('av_id','=',$product->id)->first();
                if($product_log)
                {
                    continue;
                }
                else
                {
                    dd('yes');
                    if($product->tierprice[0]->price <= $lessThan->price_key && $product->tierprice[0]->price >= $graterThan->price_key)
                    {
                        //create a product log on every product.
                        $productLog = new ProductLog;
                        $productLog->sku = $product->sku;
                        $productLog->name = $product->name;
                        $productLog->stock_quantity = $product->stock_quantity;
                        $productLog->category_id = $cat_id;
                        $productLog->action = 'Sync product from Category';
                        $productLog->save();
                        
                        $new_price = $product->tierprice[0]->price * $priceKey->price_key;
                        $desc    = '';
                        $variants = array();
                        $desc .= 'JewelleryType : '.str_replace("\n", '', $product->JewelleryType).'<br>';
                        
                        if($product->RingType)
                        {
                            $desc .= 'RingType : '.$product->RingType.'<br>';
                        }
                        if($product->RingSize)
                        {
                            $desc .= 'RingSize : '.$product->RingSize.'<br>';
                        }
                    
                        foreach ($product->specificationattributes as $key => $value) 
                        {
                            $desc .= $value->specification_attribute_name.' : '.$value->specification_attribute_value.' <br>';
                        }

                        if(count($product->attributes) > 0 && $product->JewelleryType == 'Ring' || $product->JewelleryType == 'RING' || $product->JewelleryType == 'ring')
                        {
                            $count_att = count($product->attributes[0]->attribute_values);
                            $product_data = '{"product": { "title": "'.$product->name.'",   "body_html": "<strong>'.$desc.'</strong>", "product_type": "'.$product->product_type.'", "published": true, "published_scope": "global",  "images": [ { "src": "'.$product->images[0]->src.'", "alt": "'.$product->name.'" } ], "metafields": [ { "key": "'.$product->meta_keywords.'", "value": "'.$product->meta_title.'", "value_type": "string", "namespace": "global" } ], "options": [ { "name": "Size" } ], "variants": [ ';
                            foreach ($product->attributes[0]->attribute_values as $key => $attribute_value) 
                            {
                                $variant = '{ "fulfillment_service": "manual", "inventory_management": "shopify", "inventory_policy": "continue", "inventory_quantity": '.$product->stock_quantity.', "requires_shipping": true, "sku": "'.$product->sku.'", "taxable": true, "price": '.$new_price.' , "weight": '.$product->weight.', "weight_unit": "kg", "title": "'.$product->name.'",';
                                if($key == $count_att-1)
                                {
                                    $variant .= '"option1": "'.$attribute_value->name.'"}';
                                }
                                else
                                {
                                    $variant .= '"option1": "'.$attribute_value->name.'"},';
                                }
                                $product_data .= $variant;
                                //array_push($variants,$variant);
                            }
                            $product_data .= ' ] } }';
                        }
                        else
                        {
                            $product_data = '{"product": { "title": "'.$product->name.'",   "body_html": "<strong>'.$desc.'</strong>", "product_type": "'.$product->product_type.'", "published": true, "published_scope": "global",  "images": [ { "src": "'.$product->images[0]->src.'", "alt": "'.$product->name.'" } ], "metafields": [ { "key": "'.$product->meta_keywords.'", "value": "'.$product->meta_title.'", "value_type": "string", "namespace": "global" } ], "variants": [ ';
                            $variant = '{ "fulfillment_service": "manual", "inventory_management": "shopify", "inventory_policy": "continue", "inventory_quantity": '.$product->stock_quantity.', "requires_shipping": true, "sku": "'.$product->sku.'", "taxable": true, "price": '.$new_price.' , "weight": '.$product->weight.', "weight_unit": "kg", "title": "'.$product->name.'"}';
                            $product_data .= $variant.' ] } }';
                        }
                        //dd($product_data);
                            if($product->stock_quantity >= $quantityKey->price_key)
                            {
                            $total_product++;
                            //Create a products on Shopify Store.
                            $curl = curl_init();
                            curl_setopt_array($curl, array(
                            CURLOPT_URL => "https://".env("shop-url")."/admin/api/2020-04/products.json",
                            CURLOPT_RETURNTRANSFER => true,
                            CURLOPT_ENCODING => "",
                            CURLOPT_MAXREDIRS => 10,
                            CURLOPT_TIMEOUT => 0,
                            CURLOPT_SSL_VERIFYHOST => 0,
                            CURLOPT_SSL_VERIFYPEER => 0,
                            CURLOPT_FOLLOWLOCATION => true,
                            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                            CURLOPT_CUSTOMREQUEST => "POST",
                            //CURLOPT_POSTFIELDS =>'{"product": { "title": "'.$product->name.'",   "body_html": "<strong>'.$desc.'</strong>", "product_type": "'.$product->product_type.'", "published": true, "published_scope": "global",  "images": [ { "src": "'.$product->images[0]->src.'", "alt": "'.$product->name.'" } ], "metafields": [ { "key": "'.$product->meta_keywords.'", "value": "'.$product->meta_title.'", "value_type": "string", "namespace": "global" } ], "variants": [ { "fulfillment_service": "manual", "inventory_management": "shopify", "inventory_policy": "continue", "inventory_quantity": '.$product->stock_quantity.', "requires_shipping": true, "sku": "'.$product->sku.'", "taxable": true, "price": '.$new_price.' , "weight": '.$product->weight.', "weight_unit": "kg", "title": "'.$product->name.'", "option1": "6" } ], "options":  [ { "name": "Size","values": ["6"] } ] } }',
                            CURLOPT_POSTFIELDS => $product_data,
                            CURLOPT_HTTPHEADER => array(
                                "X-Shopify-Access-Token:".env("Password"),
                                "Content-Type: application/json"
                                ),
                            ));
                        
                            $response = curl_exec($curl);
                        
                            $err = curl_error($curl);
                        
                            curl_close($curl);
                            if ($err) 
                            {
                                return response()->json(['status' => 'false', 'message' => "cURL Error #:" . $err]);
                            } 
                            else 
                            {
                                $product_response = json_decode($response);
                                //Create a product on local logs.
                                if($product_response && isset($product_response->product))
                                {
                                    $product_log = new Product;
                                    $product_log->av_id             = $product->id;
                                    $product_log->shopify_id        = $product_response->product->id;
                                    if($product->JewelleryType)
                                    {
                                        $product_log->jewellery_type = $product->JewelleryType;
                                    }
                                    //$product_log->shopify_variant_id= $product_response->product->variants[0]->id;
                                    $product_log->shopify_option_id = $product_response->product->options[0]->id;
                                    $product_log->shopify_option_values = implode(",",$product_response->product->options[0]->values);
                                    if(count($product_response->product->images) > 0)
                                    {
                                        $product_log->shopify_image_id  = $product_response->product->images[0]->id;
                                    }
                                    $product_log->name              = $product->name;
                                    $product_log->price             = $new_price;
                                    $product_log->short_description = $product->short_description;
                                    $product_log->description       = $desc;
                                    $product_log->sku               = $product->sku;
                                    $product_log->image             = $product->images[0]->src;
                                    $product_log->category_id       = $cat_id;
                                    $product_log->creating_mathod   = 'Manual Synchronization';
                                    $product_log->created_by        = Auth::user()->id;
                                    $product_log->save();
                                    foreach ($product_response->product->variants as $key => $variant) 
                                    {
                                        $productVariant = new ProductVariant;
                                        $productVariant->product_id = $product_log->id;
                                        $productVariant->shopify_variant_id = $variant->id;
                                        $productVariant->shopify_product_id = $variant->product_id;
                                        $productVariant->title = $variant->title;
                                        $productVariant->price = $variant->price;
                                        $productVariant->sku = $variant->sku;
                                        $productVariant->position = $variant->position;
                                        $productVariant->inventory_policy = $variant->inventory_policy;
                                        $productVariant->compare_at_price = $variant->compare_at_price;
                                        $productVariant->fulfillment_service = $variant->fulfillment_service;
                                        $productVariant->inventory_management = $variant->inventory_management;
                                        $productVariant->option1 = $variant->option1;
                                        $productVariant->option2 = $variant->option2;
                                        $productVariant->option3 = $variant->option3;
                                        $productVariant->taxable = $variant->taxable;
                                        $productVariant->barcode = $variant->barcode;
                                        $productVariant->grams = $variant->grams;
                                        $productVariant->image_id = $variant->image_id;
                                        $productVariant->weight = $variant->weight;
                                        $productVariant->weight_unit = $variant->weight_unit;
                                        $productVariant->inventory_item_id = $variant->inventory_item_id;
                                        $productVariant->inventory_quantity = $variant->inventory_quantity;
                                        $productVariant->old_inventory_quantity = $variant->old_inventory_quantity;
                                        $productVariant->requires_shipping = $variant->requires_shipping;
                                        $productVariant->admin_graphql_api_id = $variant->admin_graphql_api_id;
                                        $productVariant->save();
                                    }
                                }
                            }
                        }
                    }
                }
            }
            return redirect('categories-filter')->with('alert-success', 'This Category '.$total_product.' Products successfully synced on Shopify.');
        }
        else
        {
            return redirect('categories-filter')->with('alert-error', $catProducts->errors->server_error[0]);
        }
    }

    public function categoryProductShow($cat_id)
    {
        $catProducts = getCatProducts($cat_id);
        print_r(json_encode($catProducts));exit;
    }

    public function categoryProductRemove($cat_id)
    {
        //ini_set('max_execution_time', 3600);
        ini_set('memory_limit', '2024M');
        set_time_limit(0);
        $total_delete = 0;
        $variant_delete = 0;
        $product_log = Product::where('category_id','=',$cat_id)->get();
        foreach ($product_log as $key => $product) 
        {
            $total_delete++;
            //Delete product veriounts on Shopify store.
            $productVariant = ProductVariant::where('product_id','=',$product->id)->get();
            if($productVariant && !empty($productVariant))
            {
                foreach ($productVariant as $key => $variant) 
                {
                    $variant_delete++;
                    $curl = curl_init();
                    curl_setopt_array($curl, array(
                        CURLOPT_URL => "https://".env("shop-url")."/admin/api/2020-10/products/".$variant->shopify_product_id."/variants/".$variant->shopify_variant_id.".json",
                        CURLOPT_RETURNTRANSFER => true,
                        CURLOPT_ENCODING => "",
                        CURLOPT_MAXREDIRS => 10,
                        CURLOPT_TIMEOUT => 0,
                        CURLOPT_SSL_VERIFYHOST => 0,
                        CURLOPT_SSL_VERIFYPEER => 0,
                        CURLOPT_FOLLOWLOCATION => true,
                        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                        CURLOPT_CUSTOMREQUEST => "DELETE",
                        CURLOPT_HTTPHEADER => array(
                            "X-Shopify-Access-Token:".env("Password"),
                            "Content-Type: application/json"
                        ),
                    ));
                
                    $response = curl_exec($curl);
                
                    $err = curl_error($curl);
                
                    curl_close($curl);
                    if ($err) 
                    {
                        return response()->json(['status' => 'false', 'message' => "cURL Error #:" . $err]);
                    } 
                    else 
                    {
                        $delete_variant = json_decode($response);
                        //Delete product veriounts on local.
                        $variant->delete();
                    }
                }
            }

            //Delete product from Shopify store.
            $curl = curl_init();
            curl_setopt_array($curl, array(
                CURLOPT_URL => "https://".env("shop-url")."/admin/api/2020-04/products/".$product->shopify_id.".json",
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_SSL_VERIFYHOST => 0,
                CURLOPT_SSL_VERIFYPEER => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "DELETE",
                CURLOPT_HTTPHEADER => array(
                    "X-Shopify-Access-Token:".env("Password"),
                    "Content-Type: application/json"
                ),
            ));
        
            $response = curl_exec($curl);
        
            $err = curl_error($curl);
        
            curl_close($curl);
            if ($err) 
            {
                return response()->json(['status' => 'false', 'message' => "cURL Error #:" . $err]);
            } 
            else 
            {
                $delete_product = json_decode($response);
                //Delete product on local logs.
                $product->delete();
            }
        }
        return redirect('categories-filter')->with('alert-error', 'This Category '.$total_delete.' Products and his '.$variant_delete.' variant removed successfully on Shopify Store and local app');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $rules =['category' => 'required',
        'sub_category' => 'required',
        'status' => 'required',
        'title' => 'required',
        'slug' => 'required',
        'unique_id' => 'required',
        'main_image' => 'required|image|mimes:jpeg,bmp,png',
        'thumbnail' => 'required|image|mimes:jpeg,bmp,png',
        'hero_image' => 'required|image|mimes:jpeg,bmp,png'
        ];

        $validation = $this->Validate($request,$rules);

        $slug = Product::where('slug','=',$request->slug)->first();
        if(!$slug)
        {
            $unique_id = Product::where('unique_id','=',$request->unique_id)->first();
            if(!$unique_id)
            {
                $product = new Product;
                $product->category_id           = $request->category;
                $product->sub_category_id       = $request->sub_category;
                $product->status                = $request->status;
                $product->title                 = $request->title;
                $product->slug                  = $request->slug;
                $product->unique_id             = $request->unique_id;
                $product->country               = $request->country;
                $product->date                  = $request->date;
                $product->short_description     = $request->short_description;
                $product->description           = $request->description;
                $product->second_description    = $request->second_description;
                $product->meta_title            = $request->meta_title;
                $product->meta_description      = $request->meta_description;

                if($product->save())
                {
                    $product_image = new Product_image;
                    // Save Product Thumbnail Image
                    if($request->hasFile('thumbnail'))
                    {
                        $image            = $request->file('thumbnail'); 
                        $filename         = 'thumbnail_'.rand(51000,55000).'_'.time().'.'. $image->getClientOriginalExtension();
                        $destination_path = 'public/Product-Images';
                        $image->storeAs($destination_path,$filename);
                        $product_image->product_id = $product->id;
                        $product_image->type = 'thumbnail';
                        $product_image->image = $filename;
                        $product_image->save();
                    }

                    $product_image = new Product_image;
                    // Save Product Hero Image
                    if($request->hasFile('hero_image'))
                    {
                        $image            = $request->file('hero_image'); 
                        $filename         = 'hero_'.rand(66000,77000).'_'.time().'.'. $image->getClientOriginalExtension();
                        $destination_path = 'public/Product-Images';
                        $image->storeAs($destination_path,$filename);
                        $product_image->product_id = $product->id;
                        $product_image->type = 'hero_image';
                        $product_image->image = $filename;
                        $product_image->save();
                    }

                    $product_image = new Product_image;
                    // Save Product Main Image
                    if($request->hasFile('main_image'))
                    {
                        $image            = $request->file('main_image'); 
                        $filename         = 'main_'.rand(8001,12000).'_'.time().'.'. $image->getClientOriginalExtension();
                        $destination_path = 'public/Product-Images';
                        $image->storeAs($destination_path,$filename);
                        $product_image->product_id = $product->id;
                        $product_image->type = 'main_image';
                        $product_image->image = $filename;
                        $product_image->save();
                    }

                    // Save Product Normal Images
                    if($request->hasFile('images'))
                    {
                        foreach ($request->images as $key => $value) 
                        {
                            $product_image = new Product_image;
                            $image            = $value;
                            $filename         = 'normal_'.rand(2000,8000).'_'.time().'.'. $image->getClientOriginalExtension();
                            $destination_path = 'public/Product-Images';
                            $image->storeAs($destination_path,$filename);
                            $product_image->product_id = $product->id;
                            $product_image->type = 'normal_image';
                            $product_image->image = $filename;
                            $product_image->save();
                        }
                    }
                    return redirect('product')->with('alert-success', 'Product Created Successfully');
                }
                else
                {
                    return redirect('product/create')->with('alert-error', $validation->errors());
                }
            }
            else
            {
                return redirect('product/create')->with('alert-error','Please select a unique id This id already exists');
            }
        }
        else
        {
            return redirect('product/create')->with('alert-error','Please select a unique slug This slug already exists');
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $product = Product::find($id);
        return view('Backend.Products.show')->with('product',$product);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $product = Product::find($id);
        $categories = Category::where('parent','=',0)->get();
        return view('Backend.Products.edit')->with('product',$product)->with('categories',$categories);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $rules =['category' => 'required',
        'sub_category' => 'required',
        'status' => 'required',
        'title' => 'required',
        'slug' => 'required',
        'unique_id' => 'required',
        ];

        $validation = $this->Validate($request,$rules);
        $product = Product::find($id);
        if($product)
        {
            $product->category_id           = $request->category;
            $product->sub_category_id       = $request->sub_category;
            $product->status                = $request->status;
            $product->title                 = $request->title;
            $product->slug                  = $request->slug;
            $product->unique_id             = $request->unique_id;
            $product->country               = $request->country;
            $product->date                  = $request->date;
            $product->short_description     = $request->short_description;
            $product->description           = $request->description;
            $product->second_description    = $request->second_description;
            $product->meta_title            = $request->meta_title;
            $product->meta_description      = $request->meta_description;

            if($product->update())
            {
                // Save Product Thumbnail Image
                if($request->hasFile('thumbnail'))
                {
                    $product_image = Product_image::find($request->thumbnail_id);
                    if($product_image)
                    {
                        $product_image->delete();
                    }
                    $product_image = new Product_image;
                    $image            = $request->file('thumbnail'); 
                    $filename         = 'thumbnail_'.rand(9000,1100).'_'.time().'.'. $image->getClientOriginalExtension();
                    $destination_path = 'public/Product-Images';
                    $image->storeAs($destination_path,$filename);
                    $product_image->product_id = $product->id;
                    $product_image->type = 'thumbnail';
                    $product_image->image = $filename;
                    $product_image->save();
                }

                // Save Product Hero Image
                if($request->hasFile('hero_image'))
                {
                    $product_image = Product_image::find($request->hero_image_id);
                    if($product_image)
                    {
                        $product_image->delete();
                    }
                    $product_image = new Product_image;
                    $image            = $request->file('hero_image'); 
                    $filename         = 'hero_'.rand(80000,88000).'_'.time().'.'. $image->getClientOriginalExtension();
                    $destination_path = 'public/Product-Images';
                    $image->storeAs($destination_path,$filename);
                    $product_image->product_id = $product->id;
                    $product_image->type = 'hero_image';
                    $product_image->image = $filename;
                    $product_image->save();
                }

                // Save Product Main Image
                if($request->hasFile('main_image'))
                {
                    $product_image = Product_image::find($request->main_image_id);
                    if($product_image)
                    {
                        $product_image->delete();
                    }
                    $product_image = new Product_image;
                    $image            = $request->file('main_image'); 
                    $filename         = 'main_'.rand(11000,19000).'_'.time().'.'. $image->getClientOriginalExtension();
                    $destination_path = 'public/Product-Images';
                    $image->storeAs($destination_path,$filename);
                    $product_image->product_id = $product->id;
                    $product_image->type = 'main_image';
                    $product_image->image = $filename;
                    $product_image->save();
                }

                // Save Product Normal Images
                if($request->hasFile('images'))
                {
                    // $product = Product::find($id);
                    // if($product->product_images)
                    // {
                    //     foreach ($product->product_images as $key => $value) 
                    //     {
                    //         if($value->type == 'normal_image')
                    //         {
                    //             $value->delete();
                    //         }
                    //     }
                    // }
                    foreach ($request->images as $key => $value) 
                    {
                        $product_image = new Product_image;
                        $image            = $value;
                        $filename         = 'normal_'.rand(11000,15000).'_'.time().'.'. $image->getClientOriginalExtension();
                        $destination_path = 'public/Product-Images';
                        $image->storeAs($destination_path,$filename);
                        $product_image->product_id = $product->id;
                        $product_image->type = 'normal_image';
                        $product_image->image = $filename;
                        $product_image->save();
                    }
                }
            }
            return redirect('product')->with('alert-success', 'Product Updated Successfully');
        }
        else
        {
            return redirect('product')->with('alert-error', 'Product can not find');
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $product = Product::find($id);
            if($product->product_images)
            {
                foreach ($product->product_images as $key => $value) 
                {
                        $value->delete();
                }
            }
        if($product->delete())
        {    
            return redirect('product')->with('alert-error', 'Product Deleted Successfully');
        }
    }

    /**
     * Show the sub category for the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function getsubcategory(Request $request)
    {
        $categories = Category::select('title','id')->where('parent','=',$request->id)->get();
        return $categories;
    }

    public function getproduct($category_slug,$sub_category_slug,$product_unique_id,$product_slug)
    {
        $product = Product::where('unique_id','=',$product_unique_id)->first();

        return view('Frontend.product_detail')->with('product',$product);
    }

    public function getproducts_by_cat($category_slug)
    {
        $category       = Category::where('slug','=',$category_slug)->first();
        $sub_categories = Category::where('parent','=',$category->id)->get();
        $products       = Product::where('category_id','=',$category->id)->where('status','!=','archive')->orderBy('series_no', 'ASC')->get();
        return view('Frontend.category_products')->with('products',$products)->with('category',$category)->with('sub_categories',$sub_categories);
    }

    public function getproducts_by_subcat($category_slug,$sub_category_slug)
    {
        $category       = Category::where('slug','=',$category_slug)->first();
        $sub_categories = Category::where('parent','=',$category->id)->get();
        $sub_category   = Category::where('slug','=',$sub_category_slug)->where('parent','=',$category->id)->first();
        $products       = Product::where('category_id','=',$category->id)
                                ->where('sub_category_id','=',$sub_category->id)
                                ->get();
        return view('Frontend.sub_category_products')->with('products',$products)->with('category',$category)
                ->with('sub_categories',$sub_categories)->with('sub_category',$sub_category);
    }

    public function manage(Request $request)
    {
        $reorder_no = 0;
        $message = 'Product Reorder Successfully';
        foreach ($request->reorder_products as $product) {
            $reorder_no++;
            $product = Product::where('id',$product)->first();
            if($product)
            {
                $product->series_no = $reorder_no;
                $product->save();
            }
        }
        return $reorder_no;
    }

    public function image_remove(Request $request)
    {
        $product_image = Product_image::where('product_id',$request->product_id)->where('id',$request->image_id)->first();
        if($product_image->delete())
        {
            $data['response'] = 'success';
            return response()->json($data);
        }
    }
}
