@extends('layouts.app')
@section('pagetitle', 'Category Filte')
@section('subtitle', 'Set')
@section('page_css')
<link href="{{url('public/assets/select2/css/select2.min.css')}}" rel="stylesheet" type="text/css"/>
<link href="{{url('public/assets/summernote/dist/summernote.css')}}" rel="stylesheet" type="text/css"/>
<link href="{{url('public/assets/jquery-multi-select/css/multi-select.css')}}" rel="stylesheet">
@endsection
@section('content')
        <div class="row">
            <div class="col-lg-12">
                <!--breadcrumbs start -->
                <ul class="breadcrumb">
                    <li><a href="{{ url('/') }}"><i class="fa fa-home"></i> Home</a></li>
                    <li><a href="{{ redirect()->back()->getTargetUrl() }}">@yield('pagetitle')</a></li>
                    <li class="active"><strong>@yield('subtitle')</strong></li>
                </ul>
                <!--breadcrumbs end -->
            </div>
        </div>
        <div class="row">
                <div class="col-lg-12">
                    <section class="panel">
                        <header class="panel-heading">
                            @yield('pagetitle') <small> @yield('subtitle')</small>
                        </header>
                        <div class="panel-body">
                            <div class="adv-table">
                                <table  class="display table table-bordered table-striped" id="dynamic-table">
                                <thead>
                                <tr>
                                    <th>Sr.</th>
                                    <th>AV Id</th>
                                    <th>Local Id</th>
                                    <th>Category Name</th>
                                    <th>Status</th>
                                </tr>
                                </thead>
                                <tbody>
                                @php $counter = 0; @endphp
                                @foreach($categoriesFilter as $category)
                                @php $counter++ @endphp
                                <tr class="gradeX">
                                    <td>{{$counter}}</td>
                                    <td>{{$category->av_id}}</td>
                                    <td>{{$category->id}}</td>
                                    <td>{{$category->name}}</td>
                                    @if($category->published == 1)
                                        <td>{{'True'}}</td>
                                    @else
                                        <td>{{'False'}}</td>
                                    @endif
                                </tr>
                                @endforeach
                                </tbody>
                                <tfoot>
                                <tr>
                                    <th>Sr.</th>
                                    <th>AV Id</th>
                                    <th>Local Id</th>
                                    <th>Category Name</th>
                                    <th>Status</th>
                                </tr>
                                </tfoot>
                                </table>
                            </div><br><br><br>
                            <form method="post" action="{{ url('categories-filter/store') }}" class="form-horizontal tasi-form" enctype="multipart/form-data">
                                {{ csrf_field() }}
                                <div class="form-group">
                                    <label class="col-sm-2 col-sm-2 control-label">Category Filter</label>
                                    <div class="col-sm-5">
                                        <select name="cat_filter[]" id="" class="form-control select2_multiple" multiple="multiple">
                                            @if ($getCategories && isset($getCategories->categories))
                                                @foreach ($getCategories->categories as $category)
                                                    @if ($category->published == true)
                                                        @if ($category->image)
                                                            <option value="{{$category->id.','.$category->name.','.$category->published.','.$category->parent_category_id.','.$category->description.','.$category->image->src}}">{{$category->name}}</option>
                                                        @else
                                                            <option value="{{$category->id.','.$category->name.','.$category->published.','.$category->parent_category_id.','.$category->description.','}}">{{$category->name}}</option>
                                                        @endif
                                                    @endif
                                                @endforeach
                                            @endif
                                        </select>
                                    </div>
                                </div>
                                <button type="submit" class="btn btn-success">Update Filter</button>
                            </form>
                        </div>
                    </section><br><br><br><br><br><br><br><br>
                </div>
            </div>
@endsection
@section('page_js')
<script type="text/javascript" src="{{url('public/assets/select2/js/select2.min.js')}}"></script>
<script type="text/javascript" src="{{url('public/assets/jquery-multi-select/js/jquery.multi-select.js')}}"></script>
<!--select2-->
<script type="text/javascript">
    $(document).ready(function () {
        $(".js-example-basic-single").select2();
        $(".select2_multiple").select2({
            placeholder: "Select Categories For Filter",
            multiple: true,
        });
    });
</script>
<!--summernote-->
<script type="text/javascript" src="{{url('public/assets/summernote/dist/summernote.min.js')}}"></script>
<script>
    jQuery(document).ready(function(){

        $('.summernote').summernote({
            height: 200,                 // set editor height

            minHeight: null,             // set minimum height of editor
            maxHeight: null,             // set maximum height of editor
            fontNamesIgnoreCheck: ["Roboto"],
            fontNames: ["Roboto","Arial", "Arial Black", "Comic Sans MS", "Courier New",
                             "Helvetica Neue", "Helvetica", "Impact", "Lucida Grande",
                             "Tahoma", "Times New Roman", "Verdana"],
            focus: true,                 // set focus to editable area after initializing summernote
        });

    });
</script>
@endsection