@extends('layouts.app')
@section('pagetitle', 'Product')
@section('subtitle', 'Show Detail')
@section('page_css')
<link href="{{url('assets/summernote/dist/summernote.css')}}" rel="stylesheet" type="text/css"/>
@endsection
@section('content')
        <div class="row">
            <div class="col-lg-12">
                <!--breadcrumbs start -->
                <ul class="breadcrumb">
                    <li><a href="{{ url('/') }}"><i class="fa fa-home"></i> Home</a></li>
                    <li><a href="{{ redirect()->back()->getTargetUrl() }}">@yield('pagetitle')</a></li>
                    <li class="active"><strong>@yield('subtitle')</strong></li>
                </ul>
                <!--breadcrumbs end -->
            </div>
        </div>
        <div class="row">
                <div class="col-lg-12">
                    <section class="panel">
                        <header class="panel-heading">
                            @yield('pagetitle') <small> @yield('subtitle')</small>
                        </header>
                        <div class="panel-body">
                            <form class="form-horizontal tasi-form" enctype="multipart/form-data">
                                <div class="form-group">
                                    <label class="col-sm-2 col-sm-2 control-label">Product Category</label>
                                    <div class="col-sm-10">
                                        <input type="text" class="form-control" name="title" id="title" value="{{ $product->category->title }}" readonly>
                                        <small class="text-danger">{{ $errors->first('title') }}</small>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-sm-2 col-sm-2 control-label">Product Sub Category</label>
                                    <div class="col-sm-10">
                                        <input type="text" class="form-control" name="description" id="description" value="{{ $product->sub_category->title }}" readonly>
                                        <small class="text-danger">{{ $errors->first('description') }}</small>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-sm-2 col-sm-2 control-label">Product Status</label>
                                    <div class="col-sm-10">
                                        <input type="text" class="form-control" name="status" id="status" value="{{ $product->status }}" readonly>
                                        <small class="text-danger">{{ $errors->first('status') }}</small>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-sm-2 col-sm-2 control-label">Product Title</label>
                                    <div class="col-sm-10">
                                        <input type="text" class="form-control" name="title" id="title" value="{{ $product->title }}" readonly>
                                        <small class="text-danger">{{ $errors->first('title') }}</small>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-sm-2 col-sm-2 control-label">Product Slug</label>
                                    <div class="col-sm-10">
                                        <input type="text" class="form-control" name="slug" id="slug" value="{{ $product->slug }}" readonly>
                                        <small class="text-danger">{{ $errors->first('slug') }}</small>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-sm-2 col-sm-2 control-label">Product Unique Id</label>
                                    <div class="col-sm-10">
                                        <input type="text" class="form-control" name="unique_id" id="unique_id" value="{{ $product->unique_id }}" readonly>
                                        <small class="text-danger">{{ $errors->first('unique_id') }}</small>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-sm-2 col-sm-2 control-label">Short Description</label>
                                    <div class="col-sm-10">
                                        <textarea class="summernote form-control" name="short_description" id="short_description" readonly>{!! $product->short_description !!}</textarea>
                                        <small class="text-danger">{{ $errors->first('short_description') }}</small>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-sm-2 col-sm-2 control-label">Country</label>
                                    <div class="col-sm-10">
                                        <input type="text" class="form-control" name="country" id="country" value="{{ $product->country }}" readonly>
                                        <small class="text-danger">{{ $errors->first('country') }}</small>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-sm-2 col-sm-2 control-label">Date</label>
                                    <div class="col-sm-10">
                                        <input type="text" class="form-control" name="date" id="date" value="{{ $product->date }}" readonly>
                                        <small class="text-danger">{{ $errors->first('date') }}</small>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-sm-2 col-sm-2 control-label">Product Description</label>
                                    <div class="col-md-10">
                                        <textarea class="summernote form-control" name="description" id="description" readonly>{{$product->description}}</textarea>
                                        <small class="text-danger">{{ $errors->first('description') }}</small>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-sm-2 col-sm-2 control-label">Second Description</label>
                                    <div class="col-md-10">
                                        <textarea class="summernote form-control" name="second_description" id="second_description" readonly>{{$product->second_description}}</textarea>
                                        <small class="text-danger">{{ $errors->first('second_description') }}</small>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-sm-2 col-sm-2 control-label">Meta Title</label>
                                    <div class="col-sm-10">
                                        <input type="text" class="form-control" name="meta_title" id="meta_title" value="{{ $product->meta_title }}" readonly>
                                        <small class="text-danger">{{ $errors->first('meta_title') }}</small>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-sm-2 col-sm-2 control-label">Meta Description</label>
                                    <div class="col-md-10">
                                        <textarea class="summernote form-control" name="meta_description" id="meta_description" readonly>{{ $product->meta_description }}</textarea>
                                        <small class="text-danger">{{ $errors->first('meta_description') }}</small>
                                    </div>
                                </div>
                                @foreach ($product->product_images as $item)
                                    @if($item->type == 'thumbnail')
                                    <div class="form-group">
                                        <label class="col-sm-2 col-sm-2 control-label">Product Thumbnail Image</label>
                                        <div class="col-sm-10">
                                            <img  src="{{ asset('storage/Product-Images/'.$item->image) }}" height="200px" width="200px">
                                        </div>
                                    </div>
                                    @elseif($item->type == 'hero_image')
                                    <div class="form-group">
                                        <label class="col-sm-2 col-sm-2 control-label">Product Hero Image</label>
                                        <div class="col-sm-10">
                                            <img  src="{{ asset('storage/Product-Images/'.$item->image) }}" height="200px" width="200px">
                                        </div>
                                    </div>
                                    @elseif($item->type == 'main_image')
                                    <div class="form-group">
                                        <label class="col-sm-2 col-sm-2 control-label">Product Main Image</label>
                                        <div class="col-sm-10">
                                            <img  src="{{ asset('storage/Product-Images/'.$item->image) }}" height="200px" width="200px">
                                        </div>
                                    </div>
                                    @else
                                    <div class="form-group">
                                        <label class="col-sm-2 col-sm-2 control-label">Product Gallery Images</label>
                                        <div class="col-sm-10">
                                            <img  src="{{ asset('storage/Product-Images/'.$item->image) }}" height="80px" width="80px" style="border-radius: 50%;margin-right: 10px;">
                                        </div>
                                    </div>
                                    @endif
                                @endforeach
                            </form>
                        </div>
                    </section>
                </div>
        </div>
@endsection
@section('page_js')
<!--summernote-->
<script type="text/javascript" src="{{url('assets/summernote/dist/summernote.min.js')}}"></script>
<script>
    jQuery(document).ready(function(){

        $('.summernote').summernote({
            height: 200,                 // set editor height

            minHeight: null,             // set minimum height of editor
            maxHeight: null,             // set maximum height of editor
            fontNamesIgnoreCheck: ["Roboto"],
            fontNames: ["Roboto","Arial", "Arial Black", "Comic Sans MS", "Courier New",
                             "Helvetica Neue", "Helvetica", "Impact", "Lucida Grande",
                             "Tahoma", "Times New Roman", "Verdana"],
            focus: true                 // set focus to editable area after initializing summernote
        });
    });
</script>
@endsection