@extends('layouts.app')
@section('pagetitle', 'Sub Category')
@section('subtitle', 'Show Detail')
@section('page_css')
<link href="{{url('assets/summernote/dist/summernote.css')}}" rel="stylesheet" type="text/css"/>
@endsection
@section('content')
        <div class="row">
            <div class="col-lg-12">
                <!--breadcrumbs start -->
                <ul class="breadcrumb">
                    <li><a href="{{ url('/') }}"><i class="fa fa-home"></i> Home</a></li>
                    <li><a href="{{ redirect()->back()->getTargetUrl() }}">@yield('pagetitle')</a></li>
                    <li class="active"><strong>@yield('subtitle')</strong></li>
                </ul>
                <!--breadcrumbs end -->
            </div>
        </div>
        <div class="row">
                <div class="col-lg-12">
                    <section class="panel">
                        <header class="panel-heading">
                            @yield('pagetitle') <small> @yield('subtitle')</small>
                        </header>
                        <div class="panel-body">
                            <form class="form-horizontal tasi-form" enctype="multipart/form-data">
                                <div class="form-group">
                                    <label class="col-sm-2 col-sm-2 control-label">Sub Category Title</label>
                                    <div class="col-sm-10">
                                        <input type="text" class="form-control" name="title" id="title" value="{{ $sub_category->title }}" readonly>
                                        <small class="text-danger">{{ $errors->first('title') }}</small>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-sm-2 col-sm-2 control-label">Sub Category Slug</label>
                                    <div class="col-sm-10">
                                        <input type="text" class="form-control" name="slug" id="slug" value="{{ $sub_category->slug }}" readonly>
                                        <small class="text-danger">{{ $errors->first('slug') }}</small>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-sm-2 col-sm-2 control-label">Sub Category Description</label>
                                    <div class="col-sm-10">
                                        <textarea class="summernote form-control" name="description" id="description" readonly>{!! $sub_category->description !!}</textarea>
                                        <small class="text-danger">{{ $errors->first('description') }}</small>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-sm-2 col-sm-2 control-label">Sub Category Image</label>
                                    <div class="col-sm-10">
                                        @if($category->image)
                                        <img alt="task-thumb" src="{{ asset('storage/Sub-Category-Images/'.$sub_category->image)}}" height="100px" width="100px">
                                        @endif
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="col-sm-2 col-sm-2 control-label">Parent</label>
                                    <div class="col-sm-10">
                                        <input type="text" class="form-control" value="{{ $category->title }}" readonly>
                                    </div>
                                </div>
                            </form>
                        </div><br><br><br><br><br><br><br><br>
                    </section>
                </div>
        </div>
@endsection
@section('page_js')
<!--summernote-->
<script type="text/javascript" src="{{url('assets/summernote/dist/summernote.min.js')}}"></script>
<script>
    jQuery(document).ready(function(){

        $('.summernote').summernote({
            height: 200,                 // set editor height

            minHeight: null,             // set minimum height of editor
            maxHeight: null,             // set maximum height of editor
            fontNamesIgnoreCheck: ["Roboto"],
            fontNames: ["Roboto","Arial", "Arial Black", "Comic Sans MS", "Courier New",
                             "Helvetica Neue", "Helvetica", "Impact", "Lucida Grande",
                             "Tahoma", "Times New Roman", "Verdana"],
            focus: true                 // set focus to editable area after initializing summernote
        });
    });
</script>
@endsection